/**************************************************
 * soubor fn-argn.c
 * funkce s promnnm potem argument rznch typ
 **************************************************/

#include <stdio.h>
#include <stdarg.h>

double polynom(short pocet, ...)
/**************************************************
 * vysl polynom an*x^n + an-1*x^n-1 + ... a1*x + a0
 * poet = poet vech koeficient (n+1), nsleduje
 * x typu double, koeficienty typu int
 **************************************************/
{
 double hodnota = 0.0, x;      va_list ap;

 va_start(ap, pocet);
 x = va_arg(ap, double);
 while (pocet-- != 0)
     hodnota = hodnota * x + va_arg(ap, int);
 va_end(ap);
 return hodnota;
}

int main(void)
{
 double x, f;
 
 x = 2.0;
 /* pol. st. 2; 2x^2 + 3x + 4, x=2 -> 18 */
 f = polynom(3, x, 2, 3, 4);          
 printf("p(%lf) = %lf\n", x, f);

 x = 3.0;
 /* pol. st. 3; x^3, x=3 -> 27 */
 f = polynom(4, x, 1, 0, 0, 0);       
 printf("p(%lf) = %lf\n", x, f);

 x = 5.0;
 /* pol. st. 4; 2x^4 - 10x^3 + 2x^2 + 3x - 1, x=5 -> 64 */
 f = polynom(5, x, 2, -10, 2, 3, -1); 
 printf("p(%lf) = %lf\n", x, f);
 return 0;
}

