/********************************************
 * soubor fn-qsrt.c
 * ukazuje pouit qsort() a definici a petypovn
 * uivatelsk srovnvac funkce
 ********************************************/

#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#define	POCET 	        1000000
#define	RND_START	1234

int float_sort (const float *a, const float *b)
{
 return (int) (*a - *b);	/* <0, ==0, >0	*/
} /* int float_sort (const float *a, const float *b) */

void test (float *p, unsigned int pocet)
/* otestuje zda je dan pole setdno vzestupn	*/
{
 int chyba = 0;
 for (; !chyba && --pocet > 0; p++)
   if (*p > *(p+1))
     chyba=1;
 puts ((chyba) ? "\npole neni setrideno\n"
	       : "\npole je setrideno\n");
} /* void test (float *p,unsigned int pocet) */

void vypln(float *p, int pocet)
/* vypln pole dan adresou a potem prvk nhodnmi
 * sly vytvoenmi genertorem nhodnch sel		*/
{
 srand(RND_START);
 while (pocet-- > 0)
    *p++ = (float) rand();
} /* void vypln(float *p, int pocet) */

int main (void)
{
 static float pole [POCET];
 vypln (pole, POCET);
 clock(); /* zatek potn asu */
 qsort(pole, POCET, sizeof(*pole),
	(int (*) (const void *, const void *)) float_sort);
 printf ("Trideni qsort trvalo %.2fs\n",
        ((float) clock()) / CLOCKS_PER_SEC);
 /* uplynul as v ticch peveden na sekundy */
 test (pole, POCET);
 return 0;
}   /* int main (void)  */
