/*******************************************
 * soubor dedi-min.cpp
 * ddinost pm, sekundy -> minuty
 * minuty a sekundy mohou bt jen nezporn
 *******************************************/
#include <iostream>
#include <iomanip>
using namespace std;

const int MEZ_S = 60;

class sekundy {
	int s;
  public:
	sekundy() {s = 0;}
	sekundy(int pocatek) {s = pocatek;}
	~sekundy();
	int dej_s() {return s;}
	int nastav_s(int hodnota) {return s = hodnota;}
	void zvys() {s++; }
	void sniz() {
		if (s > 0) s--;
	}
}; // class sekundy

ostream& operator << (ostream& os, sekundy& s) {
	os << setw(2) << setfill('0') << s.dej_s();
	return os;
}

sekundy::~sekundy() {
	cout << "~sekundy(), " << *this << endl;
}

class minuty : public sekundy {
	int m;
	void kontrola_uprava() {
		int pomocna;
		if ((pomocna = dej_s()) >= MEZ_S) {
			nastav_s(pomocna % MEZ_S);
			m += pomocna / MEZ_S;
		} else if (pomocna < 0) {
			nastav_s(pomocna % MEZ_S);
			m -= pomocna / MEZ_S;
		}
	} // void kontrola_uprava()
  public:
	minuty(int mi, int se) : sekundy(se), m(mi) {
		kontrola_uprava();
	}
	~minuty();
	void zvys() {
		sekundy::zvys();
		kontrola_uprava();
	}
	void sniz() {
		if (dej_s() == 0) {
			if (m > 0) {
				m--;
				nastav_s(MEZ_S);
			} 
		}
		sekundy::sniz();
		kontrola_uprava();
	}
	int dej_m() {return m;}
}; // class minuty

ostream& operator << (ostream& os, minuty& m) {
	os << "mm.ss "<< setw(2) << setfill('0') << m.dej_m() 
	   << '.' << setw(2) << setfill('0') << m.dej_s();
	return os;
}

minuty::~minuty() {
	cout << "~minuty(), " << *this << endl;
}

int main() {
	sekundy s;
	int i;
	cout << "sekund je " << s << endl;
	for (i = 0; i < 100; i++)
		s.zvys();	
	cout << "sekund je " << s << ", 100x zvys()" << endl;
	s.nastav_s(999);
	cout << "sekund je " << s << ", nastav 999" << endl;
	for (i=0; i < 100; i++)
		s.sniz();
	cout << "sekund je " << s << ", 100x sniz()" << endl;
	cout << "--------------------" << endl;

	minuty minutka(1, 60);
	cout << minutka << ", 120 sekund " << endl;
	minutka.zvys();
	cout << minutka << ", 1x zvys()" << endl;

	for (i = 0; i < 100; i++)
		minutka.zvys();
	cout << minutka << ", 100x zvys()"<< endl;
	for (i=0; i < 100; i++)
		minutka.sniz();
	cout << minutka << ", 100x sniz()"<< endl
		 << "------------ konec tisku" << endl;
    return 0;
} // int main()